//	Created by Ben Zelonka (zelonka@globalserve.on.ca)

//	---------------POV-RAY Tardis---------------
//	I know it's messy, but it's my first project.


#include "chars.inc"

#declare Tardis_Color=texture{
	pigment{
	colour rgb <0.031,0.078,0.247>}
	normal{ bumps 0.14}
	finish {ambient 0.2 specular 0.3 roughness 0.2 crand 0.03}}

#declare Tardis_Glass=texture{
	pigment{
	colour rgbf <0.816,0.824,0.729,0.294>}
	normal{ wrinkles 0.2
	scale <2.0, 2.0, 2.0>}
	finish { specular 0.14 roughness 0.1 reflection 0.09
	refraction 1.0 ior 1.46}}


#declare Pillar=union{
object {box{
	<0,0,0>
	<.3,5,.3>}}
object {box{
	<0,0,0>
	<.25,.2,.25>
	translate <.025,4.9,.025>}}}

#declare Light=union{
object {cylinder{
	<0,0,0>
	<0,1,0>
	0.5
	texture {Tardis_Glass}
	translate <0,0,0>}}
difference{
union{
object {sphere{
	<0,1,0> .5
	scale <1,.95,1>}}
object {cylinder{
	<0,1,0>
	<0,1.05,0>
	.8}}
object {box{
	<0,0,0>
	<1.5,.7,1.5>}
	translate <-.75,-.7,-.75>}
object {box{
	<0,0,0>
	<1.5,1,.1>
	translate <-.75,0,0>
	rotate y*45}}
object {box{
	<0,0,0>
	<1.5,1,.1>
	translate <-.75,0,0>
	rotate y*-45}}}
object {cylinder{
	<0,0,0>
	<0,1,0>
	.5}}}}

#declare Angle=
object {box{
	<-1.5,-1.5,-.5>
	<1.5,1.5,.5>
	rotate x*75
	translate <0,.3,-1.075>}}

#declare Sign1=union{
object {box{
	<0,0,0>
	<2.5,.3,.1>
	translate <-1.5,-.075,.02>
	pigment {rgb <0,0,.3>}
	finish {Dull}}}
union{
object {char_P
	translate <0,0,0>}
object {char_O
	translate <5,0,0>}
object {char_L
	translate <10,0,0>}
object {char_I
	translate <15,0,0>}
object {char_C
	translate <20,0,0>}
object {char_E
	translate <25,0,0>}
scale <.03,.03,.03>
translate <-1.25,0,.01>}
union{
object {char_B
	translate <45,0,0>}
object {char_O
	translate <50,0,0>}
object {char_X
	translate <55,0,0>}
scale <.03,.03,.03>
translate <-1,0,.01>}
union{
object {char_P
	translate <30,6,0>}
object {char_U
	translate <35,6,0>}
object {char_B
	translate <40,6,0>}
object {char_L
	translate <45,6,0>}
object {char_I
	translate <50,6,0>}
object {char_C
	translate <55,6,0>}
object {char_C
	translate <35,0,0>}
object {char_A
	translate <40,0,0>}
object {char_L
	translate <45,0,0>}
object {char_L
	translate <50,0,0>}
scale <.01,.01,.01>
translate <-.5,.01,.01>}
pigment {White}
translate <.25,-.425,-1.575>
translate <0,1.87875,0>
bounded_by {box{
	<-.1,-.1,-.1>
	<2.6,.4,.2>
	translate <-1.25,1.37875,-1.555>}}}

#declare Roof=union{
box{<0,0,0>
	<2.7,.5,2.7>}
box {<0,0,0>
	<2.38,.5,2.38>
	translate <.16,.2,.16>}
box{<0,0,0>
	<2.60,.4,3.1>
	translate <.05,-.3,-.2>}
box{<0,0,0>
	<3.1,.4,2.60>			
	translate <-.2,-.3,.05>}
difference{
object {box{
	<-1.19,-.25,-1.19>
	<1.19,.25,1.19>}}
object {Angle}
object {Angle
	rotate y*90}
object {Angle
	rotate y*180}
object {Angle
	rotate y*-90}
	translate <1.35,.95,1.35>}
object {Light
	scale <.3,.3,.3>
	translate <1.35,1.15,1.35>}}

#declare Hole=
object{box{
	<0,0,-.1>
	<.65,.75,1>}}

#declare Siding=difference{
object {box{
	<0,0,0>
	<2.5,4.5,.1>
	translate <0,0,0>}}
object {Hole
	translate <.4,3.5,0>}
object {Hole
	translate <.4,2.5,0>}
object {Hole
	translate <.4,1.5,0>}
object {Hole
	translate <.4,.5,0>}
object {Hole
	translate <1.4,3.5,0>}
object {Hole
	translate <1.4,2.5,0>}
object {Hole
	translate <1.4,1.5,0>}
object {Hole				
	translate <1.4,.5,0>}}

#declare HoleB=
object{box{
	<0,0,-.1>
	<.62,.72,1>}}

#declare Siding2=difference{
object {box{
	<0,0,0>
	<2.5,4.5,.1>}}
object {HoleB
	translate <.415,3.515,0>}
object {HoleB
	translate <.415,2.515,0>}
object {HoleB
	translate <.415,1.515,0>}
object {HoleB
	translate <.415,.515,0>}
object {HoleB
	translate <1.415,3.515,0>}
object {HoleB
	translate <1.415,2.515,0>}
object {HoleB
	translate <1.415,1.515,0>}
object {HoleB
	translate <1.415,.515,0>}}

#declare Hole2=union{
object {box{
	<0,0,0>
	<.17,.33,.5>}
	translate <0,0,0>}
object {box{
	<0,0,0>
	<.17,.33,.5>}
	translate <.2,0,0>}
object {box{
	<0,0,0>
	<.17,.33,.5>}
	translate <.4,0,0>}
object {box{
	<0,0,0>
	<.17,.33,.5>}
	translate <0,.35,0>}
object {box{
	<0,0,0>
	<.17,.33,.5>}
	translate <.2,.35,0>}
object {box{
	<0,0,0>
	<.17,.33,.5>}
	translate <.4,.35,0>}}

#declare Glass1=union{
object {box{
	<0,0,0>
	<.17,.3,.1>}
	translate <0,0,0>}
object {box{
	<0,0,0>
	<.17,.3,.1>}
	translate <.2,0,0>}
object {box{
	<0,0,0>
	<.17,.3,.1>}
	translate <.4,0,0>}
object {box{
	<0,0,0>
	<.17,.3,.1>}
	translate <0,.35,0>}
object {box{
	<0,0,0>
	<.17,.3,.1>}
	translate <.2,.35,0>}
object {box{
	<0,0,0>
	<.17,.3,.1>}
	translate <.4,.35,0>}
texture {Tardis_Glass}}

#declare Wall=union{
difference{
	box{
	<0,0,0>
	<2.5,5,.1>
	translate <0,0,.1>}
object {Hole2
	translate <1.44,3.54,-.1>}
object {Hole2
	translate <.44,3.54,-.1>}}
object {Glass1
	translate <1.44,3.54,.1>}
object {Glass1
	translate <.44,3.54,.1>}
object {Siding}
object {Siding2
	translate <0,0,.025>}
object {box{
	<0,0,0>
	<.05,4.5,.5>
	translate <1.2,0,-.02>}}
object {box{
	<0,4.4,-.02>
	<2.5,4.5,.5>
	finish {ambient 1}}}}

#declare WallD=union{
difference{
	box{
	<0,0,0>
	<2.5,5,.1>
	translate <0,0,.1>}
object {Hole2
	translate <1.44,3.54,-.1>}
object {Hole2
	translate <.44,3.54,-.1>}}
object {Glass1
	translate <1.44,3.54,.1>}
object {Glass1
	translate <.44,3.54,.1>}
object {Siding}
difference{
object {Siding2
	translate <0,0,.025>}
object {Hole
	translate <.4,2.5,0>}}
object {box{
	<0,0,0>
	<.05,4.5,.5>
	translate <1.2,0,-.02>}}
object {box{
	<0,4.4,-.02>
	<2.5,4.5,.5>}}}

#declare Sign2=union{
object {box{
	<0,0,0>
	<.5,.6,.5>
	translate <.475,2.575,.075>
	pigment {color rgb <0,0,.2>}
	finish {Dull}}}
union{
union{
object {char_P
	translate <0,0,0>}
object {char_O
	translate <5,0,0>}
object {char_L
	translate <10,0,0>}
object {char_I
	translate <15,0,0>}
object {char_C
	translate <20,0,0>}
object {char_E
	translate <25,0,0>}
object {char_T
	translate <32.5,0,0>}
object {char_E
	translate <37.5,0,0>}
object {char_L
	translate <42.5,0,0>}
object {char_E
	translate <47.5,0,0>}
object {char_P
	translate <52.5,0,0>}
object {char_H
	translate <57.5,0,0>}
object {char_O
	translate <62.5,0,0>}
object {char_N
	translate <67.5,0,0>}
object {char_E
	translate <72.5,0,0>}
scale <.05,.05,.05>
translate <-1,0,0>}

union{
object {char_F
	translate <0,0,0>}
object {char_R
	translate <5,0,0>}
object {char_E
	translate <10,0,0>}
object {char_E
	translate <15,0,0>}
object {char_F
	translate <-10,-6,0>}
object {char_O
	translate <-5,-6,0>}
object {char_R
	translate <0,-6,0>}
object {char_U
	translate <7.5,-6,0>}
object {char_S
	translate <12.5,-6,0>}
object {char_E
	translate <17.5,-6,0>}
object {char_O
	translate <25,-6,0>}
object {char_F
	translate <30,-6,0>}
scale <.03,.03,.03>
translate <.5,-.65,0>}

union{
object {char_P
	translate <0,0,0>}
object {char_U
	translate <5,0,0>}
object {char_B
	translate <10,0,0>}
object {char_L
	translate <15,0,0>}
object {char_I
	translate <20,0,0>}
object {char_C
	translate <25,0,0>}
scale <.05,.05,.05>
translate <.175,-1.15,0>}

union{
object {char_A
	translate <0,0,0>}
object {char_D
	translate <5,0,0>}
object {char_V
	translate <10,0,0>}
object {char_I
	translate <15,0,0>}
object {char_C
	translate <20,0,0>}
object {char_E
	translate <25,0,0>}
object {char_A
	translate <32.5,0,0>}
object {char_N
	translate <37.5,0,0>}
object {char_D
	translate <42.5,0,0>}
object {char_A
	translate <50,0,0>}
object {char_S
	translate <55,0,0>}
object {char_S
	translate <60,0,0>}
object {char_I
	translate <65,0,0>}
object {char_S
	translate <70,0,0>}
object {char_T
	translate <75,0,0>}
object {char_A
	translate <80,0,0>}
object {char_N
	translate <85,0,0>}
object {char_C
	translate <90,0,0>}
object {char_E
	translate <95,0,0>}
scale <.03,.03,.03>
translate <-.65,-1.8,0>}

union{
object {char_O
	translate <0,0,0>}
object {char_B
	translate <5,0,0>}
object {char_T
	translate <10,0,0>}
object {char_A
	translate <15,0,0>}
object {char_I
	translate <20,0,0>}
object {char_N
	translate <25,0,0>}
object {char_A
	translate <30,0,0>}
object {char_B
	translate <35,0,0>}
object {char_L
	translate <40,0,0>}
object {char_E
	translate <45,0,0>}
object {char_I
	translate <52.5,0,0>}
object {char_M
	translate <57.5,0,0>}
object {char_M
	translate <62.5,0,0>}
object {char_E
	translate <67.5,0,0>}
object {char_D
	translate <72.5,0,0>}
object {char_I
	translate <77.5,0,0>}
object {char_A
	translate <82.5,0,0>}
object {char_T
	translate <87.2,0,0>}
object {char_E
	translate <92.5,0,0>}
object {char_L
	translate <97.5,0,0>}
object {char_Y
	translate <102.5,0,0>}
scale <.03,.03,.03>
translate <-.75,-2.05,0>}

union{
object {char_O
	translate <5,0,0>}
object {char_F
	translate <10,0,0>}
object {char_F
	translate <15,0,0>}
object {char_I
	translate <20,0,0>}
object {char_C
	translate <25,0,0>}
object {char_E
	translate <30,0,0>}
object {char_R
	translate <35,0,0>}
object {char_S
	translate <40,0,0>}
object {char_A
	translate <47.5,0,0>}
object {char_N
	translate <52.5,0,0>}
object {char_D
	translate <57.5,0,0>}
object {char_C
	translate <65,0,0>}
object {char_A
	translate <70,0,0>}
object {char_R
	translate <75,0,0>}
object {char_S
	translate <80,0,0>}
scale <.03,.03,.03>
translate <-.5,-2.8,0>}

union{
object {char_R
	translate <0,0,0>}
object {char_E
	translate <5,0,0>}
object {char_S
	translate <10,0,0>}
object {char_P
	translate <15,0,0>}
object {char_O
	translate <20,0,0>}
object {char_N
	translate <25,0,0>}
object {char_D
	translate <30,0,0>}
object {char_T
	translate <37.5,0,0>}
object {char_O
	translate <42.5,0,0>}
scale <.03,.03,.03>
translate <.1,-3.05,0>}

union{
object {char_U
	translate <0,0,0>}
object {char_R
	translate <5,0,0>}
object {char_G
	translate <10,0,0>}
object {char_E
	translate <15,0,0>}
object {char_N
	translate <20,0,0>}
object {char_T
	translate <25,0,0>}
object {char_C
	translate <32.5,0,0>}
object {char_A
	translate <37.5,0,0>}
object {char_L
	translate <42.5,0,0>}
object {char_L
	translate <47.5,0,0>}
object {char_S
	translate <52.5,0,0>}
scale <.03,.03,.03>
translate <-.05,-3.3,0>}

union{
object {char_P
	translate <0,0,0>}
object {char_U
	translate <5,0,0>}
object {char_L
	translate <10,0,0>}
object {char_L
	translate <15,0,0>}
object {char_T
	translate <22.5,0,0>}
object {char_O
	translate <27.5,0,0>}
object {char_O
	translate <35,0,0>}
object {char_P
	translate <40,0,0>}
object {char_E
	translate <45,0,0>}
object {char_N
	translate <50,0,0>}
scale <.05,.05,.05>
translate <-.35,-4.15,0>}

scale <.1,.1,.1>
translate <.65,3.075,.07>}
pigment {White}

bounded_by {box{
	<-.1,-.1,-.1>
	<.6,.7,.6>
	translate <.475,2.575,.075>}}}

#declare Screw=difference{
object {sphere{
	<0,0,0> .1}}
object {box{
	<-.2,-.025,-.2>
	<.2,.025,-.025>}}
scale <.3,.3,.15>}

#declare Handle=union{
object{torus{.3, .05
	rotate z*90
	scale <1,1,.75>}}
object {box{
	<-.05,.3,0>
	<.05,.5,.1>}}
object {cylinder{
	<0,.5,0>
	<0,.5,.1> .05}}
object {box{
	<-.05,-.3,0>
	<.05,-.5,.1>}}
object {cylinder{
	<0,-.5,0>
	<0,-.5,.1> .05}}
scale <.5,.5,.5>
pigment {color rgb <.3,.3,.5>}}

#declare Door=union{
object {WallD}
union{
difference{
object {box{
	<0,0,0>
	<.6,.7,.2>
	translate <.425,2.525,-.001>}}
object {box{
	<0,0,0>
	<.5,.6,1>
	translate <.475,2.575,-.5>}}}
object {Sign2}
union{
object {Screw
	rotate z*50
	translate <0,.5,0>}
object {Screw
	rotate z*15
	translate <0,.4,0>}
object {Screw
	rotate z*-60
	translate <0,-.5,0>}
object {Screw
	rotate z*-80
	translate <0,-.4,0>}
scale <.5,.5,.5>
translate <1,2.9,-.01>}
object {Handle
	translate <1,2.9,-.01>}}

union{
object {Screw
	rotate z*30
	translate <0,.5,0>}
object {Screw
	rotate z*5
	translate <0,.4,0>}
object {Screw
	rotate z*-25
	translate <0,-.5,0>}
object {Screw
	rotate z*80
	translate <0,-.4,0>}
scale <.5,.5,.5>
translate <1.325,2.9,-.01>}
object {Handle
	translate <1.325,2.9,-.01>}

difference{
object {cylinder{
	<0,0,0>
	<0,0,.1> .04
	pigment {Gray}
	finish {Shiny}}}
object {box{
	<-.01,-.03,-.1>
	<.01,.03,.05>
	pigment {Black}}}
translate <1.325,2.55,-.01>}}

#declare Tardis=union{
union{
object {box{
	<0,0,0>
	<3,.2,3>
	translate <0,-2.1,0>}}		
object {Pillar
	translate <.05,-2,.05>}
object {Pillar
	translate <2.65,-2,.05>}
object {Pillar
	translate <2.65,-2,2.65>}
object {Pillar				
	translate <.05,-2,2.65>}
object {Roof
	translate <.15,2.75,.15>}
object {Wall
	translate <.25,-2,.2>}
object {Wall
	rotate y*90
	translate <.25,-2,2.8>}
object {Wall
	rotate y*180
	translate <2.75,-2,2.8>}
object {Door
	rotate y*-90
	translate <2.85,-2,.3>}
translate <-1.5,-1.12125,-1.5>}
object {Sign1}
object {Sign1
	rotate y*90}
object {Sign1
	rotate y*180}
object {Sign1
	rotate y*-90}
texture {Tardis_Color}}